#include <stdio.h>
#include <stdlib.h>
#include <string.h>

static int
compare (const void *a, const void *b)
{
  const char *aa = *(const char **)a;
  const char *bb = *(const char **)b;
  return strcmp (aa, bb);
}

int
main (int argc, char *argv[])
{
  int n = 102; // includes \n and \0

  char **list = malloc (sizeof (char *));
  if (list == NULL)
    {
      perror ("malloc");
      exit (EXIT_FAILURE);
    }

  int index = 0;

  int finished = 0;
  while (!finished)
    {
      char buf[n];
      if (fgets (buf, n, stdin) == NULL)
        {
          if (ferror (stdin))
            {
              perror ("fgets");
              exit (EXIT_FAILURE);
            }
          else
            {
              finished = 1;
              break;
            }
        }

      if (buf[strlen (buf) - 1] != '\n')
        {
          if (strlen (buf) < n - 1)
            {
              finished = 1;
            }
          else
            {
              int c;
              while ((c = fgetc (stdin)) != '\n')
                {
                  if (c == EOF)
                    {
                      if (ferror (stdin))
                        {
                          perror ("fgetc");
                        }
                      else
                        {
                          finished = 1;
                          break;
                        }
                    }
                }
              continue;
            }
        }

      if (buf[strlen (buf) - 1] == '\n')
        {
          buf[strlen (buf) - 1] = '\0';
        }

      if (strlen (buf) == 0)
        {
          continue;
        }

      list = realloc (list, (index + 1) * sizeof (char *));
      if (list == NULL)
        {
          perror ("realloc");
          exit (EXIT_FAILURE);
        }

      list[index] = malloc (n - 1);
      if (list[index] == NULL)
        {
          perror ("malloc");
          exit (EXIT_FAILURE);
        }

      strcpy (list[index], buf);
      index++;
    }

  qsort (list, index, sizeof (list[0]), compare);

  for (int i = 0; i < index; i++)
    {
      if (fputs (list[i], stdout) == EOF || fputs ("\n", stdout) == EOF)
        {
          perror ("fputs");
          exit (EXIT_FAILURE);
        }
      free (list[i]);
    }
  free (list);

  if (fflush (stdout) == EOF)
    {
      perror ("fflush");
      exit (EXIT_FAILURE);
    }

  return EXIT_SUCCESS;
}
